"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
 * Created by charles on 16/8/18.
 */
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var dropdown_item_component_1 = require("./dropdown-item.component");
var CUSTOM_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DropDownComponent; }),
    multi: true
};
var DropDownComponent = (function () {
    function DropDownComponent() {
        /**
         * 选中事件发射器
         * @type {EventEmitter<any>}
         */
        this.selectEmitter = new core_1.EventEmitter();
        /**
         * 输入框显示文字
         * @type {string}
         */
        this.text = '';
        /**
         * 输入框提示
         * @type {string}
         */
        this.placeholder = '';
    }
    DropDownComponent.prototype.writeValue = function (obj) {
        this.model = obj;
        if (this.itemList) {
            this.itemList.forEach(function (item) {
                item.init(obj);
            });
        }
    };
    DropDownComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    DropDownComponent.prototype.registerOnTouched = function (fn) {
    };
    DropDownComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.itemList.forEach(function (item) {
            item.selectEmitter.subscribe(function (event) {
                _this.hide();
                _this.text = event.text;
                _this.model = event.value;
                _this.onChange(_this.model);
                _this.selectEmitter.emit({
                    text: _this.text,
                    value: _this.model,
                });
                _this.itemList.forEach(function (i) {
                    if (i !== item) {
                        i.unSelect();
                    }
                });
                item.select();
            });
        });
    };
    /**
     * 输入框点击事件
     * @param event
     */
    DropDownComponent.prototype.onClick = function (event) {
        this.active = true;
        event.stopPropagation();
    };
    /**
     * 隐藏下拉框
     */
    DropDownComponent.prototype.hide = function () {
        this.active = false;
    };
    __decorate([
        core_1.Output('select'), 
        __metadata('design:type', core_1.EventEmitter)
    ], DropDownComponent.prototype, "selectEmitter", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DropDownComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.ContentChildren(dropdown_item_component_1.DropDownItemComponent), 
        __metadata('design:type', core_1.QueryList)
    ], DropDownComponent.prototype, "itemList", void 0);
    DropDownComponent = __decorate([
        core_1.Component({
            selector: 'lui-dropdown',
            template: "\n        <div class=\"drop-container\" (document:click)=\"hide()\">\n            <input (click)=\"onClick($event)\" type=\"text\" class=\"input-drop input-dropdown-standard-md\" readOnly \n                [placeholder]=\"placeholder\" [value]=\"text\">\n            <div class=\"dropdown-list\" [ngClass]=\"{'show': active}\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    ",
            directives: [dropdown_item_component_1.DropDownItemComponent],
            providers: [CUSTOM_VALUE_ACCESSOR]
        }), 
        __metadata('design:paramtypes', [])
    ], DropDownComponent);
    return DropDownComponent;
}());
exports.DropDownComponent = DropDownComponent;
//# sourceMappingURL=dropdown.component.js.map